V = 0
Q1 = $(V:1=)
Q = $(Q1:0=@)
n=$(NULLCMD)
ECHO1 = $(V:1=@$n)
ECHO = $(ECHO1:0=@echo)

encsrcdir = ../ruby-2.0.0-p0/enc
topdir = .
prefix = /usr
exec_prefix = $(prefix)
libdir = $(exec_prefix)/lib
top_srcdir = $(encsrcdir:/enc=)
srcdir = $(top_srcdir)
arch = i386-mswin32_110
EXTOUT = .ext
hdrdir = $(srcdir)/include
arch_hdrdir = $(EXTOUT)/include/$(arch)
ENCSODIR = $(EXTOUT)/$(arch)/enc
TRANSSODIR = $(ENCSODIR)/trans
DLEXT = so
OBJEXT = obj
LIBEXT = lib

BUILTIN_ENCS	= ascii.c us_ascii.c\
		  unicode.c utf_8.c

BUILTIN_TRANSES	= newline.trans

RUBY_SO_NAME = ruby200
LIBRUBY = $(RUBY_SO_NAME).lib
LIBRUBYARG_SHARED = $(LIBRUBY)
LIBRUBYARG_STATIC = $(LIBRUBYARG_SHARED)

empty =
AR = lib -nologo
CC = cl -nologo
RANLIB = 
OUTFLAG = -Fe$(empty)
COUTFLAG = -Fo$(empty)
CFLAGS = $(CCDLFLAGS) -MD -Zi -W2 -wd4996 -we4028 -we4142 -O2sy-  -Zm600 
cflags = @cflags@
optflags = @optflags@
debugflags = @debugflags@
warnflags = @warnflags@
CCDLFLAGS = 
INCFLAGS = -I. -I$(arch_hdrdir) -I$(hdrdir) -I$(top_srcdir)
DEFS = 
CPPFLAGS =    -DONIG_ENC_REGISTER=rb_enc_register
LDFLAGS = -incremental:no -opt:ref -opt:icf
LDSHARED = cl -nologo -LD
ldflags  = $(LDFLAGS)
dldflags = -incremental:no -opt:ref -opt:icf -dll $(LIBPATH)
extdldflags = 
archflag = 
DLDFLAGS = $(ldflags) $(dldflags) $(extdldflags) $(archflag)
RUBY     = $(MINIRUBY)
TARGET_NAME_ = $(@F) # BSD make seems unable to deal with @F with substitution
TARGET_NAME = $(TARGET_NAME_:.so=)
TARGET_ENTRY =  Init_$(TARGET_NAME)

WORKDIRS = $(ENCSODIR) $(TRANSSODIR) enc enc/trans

NULLCMD = :
RM = $(COMSPEC) /C $(top_srcdir:/=\)\win32\rm.bat
RMDIR = $(COMSPEC) /C $(top_srcdir:/=\)\win32\rmdirs.bat
RMDIRS = $(COMSPEC) /C $(top_srcdir:/=\)\win32\rmdirs.bat
MAKEDIRS = $(MINIRUBY) -run -e mkdir -- -p

.SUFFIXES: .trans

all: make-workdir

make-workdir:
	$(Q)$(MAKEDIRS) $(WORKDIRS)

clean:

distclean: clean
	$(Q)$(RM) enc.mk
realclean: distclean clean-srcs

#### depend ####


VPATH = $(arch_hdrdir)/ruby;$(hdrdir)/ruby;$(srcdir);$(encsrcdir)
LIBPATH =  -libpath:. -libpath:$(topdir)
LIBS = $(LIBRUBYARG_SHARED) oldnames.lib user32.lib advapi32.lib shell32.lib ws2_32.lib imagehlp.lib shlwapi.lib  $(EXTLIBS)

ENCOBJS = enc/encdb.$(OBJEXT) \
	  enc/big5.$(OBJEXT) \
	  enc/cp949.$(OBJEXT) \
	  enc/emacs_mule.$(OBJEXT) \
	  enc/encinit.$(OBJEXT) \
	  enc/euc_jp.$(OBJEXT) \
	  enc/euc_kr.$(OBJEXT) \
	  enc/euc_tw.$(OBJEXT) \
	  enc/gb2312.$(OBJEXT) \
	  enc/gb18030.$(OBJEXT) \
	  enc/gbk.$(OBJEXT) \
	  enc/iso_8859_1.$(OBJEXT) \
	  enc/iso_8859_2.$(OBJEXT) \
	  enc/iso_8859_3.$(OBJEXT) \
	  enc/iso_8859_4.$(OBJEXT) \
	  enc/iso_8859_5.$(OBJEXT) \
	  enc/iso_8859_6.$(OBJEXT) \
	  enc/iso_8859_7.$(OBJEXT) \
	  enc/iso_8859_8.$(OBJEXT) \
	  enc/iso_8859_9.$(OBJEXT) \
	  enc/iso_8859_10.$(OBJEXT) \
	  enc/iso_8859_11.$(OBJEXT) \
	  enc/iso_8859_13.$(OBJEXT) \
	  enc/iso_8859_14.$(OBJEXT) \
	  enc/iso_8859_15.$(OBJEXT) \
	  enc/iso_8859_16.$(OBJEXT) \
	  enc/koi8_r.$(OBJEXT) \
	  enc/koi8_u.$(OBJEXT) \
	  enc/shift_jis.$(OBJEXT) \
	  enc/utf_16be.$(OBJEXT) \
	  enc/utf_16le.$(OBJEXT) \
	  enc/utf_32be.$(OBJEXT) \
	  enc/utf_32le.$(OBJEXT) \
	  enc/windows_31j.$(OBJEXT) \
	  enc/windows_1251.$(OBJEXT)

ENCSOS = $(ENCSODIR)/encdb.$(DLEXT) \
	 $(ENCSODIR)/big5.$(DLEXT) \
	 $(ENCSODIR)/cp949.$(DLEXT) \
	 $(ENCSODIR)/emacs_mule.$(DLEXT) \
	 $(ENCSODIR)/encinit.$(DLEXT) \
	 $(ENCSODIR)/euc_jp.$(DLEXT) \
	 $(ENCSODIR)/euc_kr.$(DLEXT) \
	 $(ENCSODIR)/euc_tw.$(DLEXT) \
	 $(ENCSODIR)/gb2312.$(DLEXT) \
	 $(ENCSODIR)/gb18030.$(DLEXT) \
	 $(ENCSODIR)/gbk.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_1.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_2.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_3.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_4.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_5.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_6.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_7.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_8.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_9.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_10.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_11.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_13.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_14.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_15.$(DLEXT) \
	 $(ENCSODIR)/iso_8859_16.$(DLEXT) \
	 $(ENCSODIR)/koi8_r.$(DLEXT) \
	 $(ENCSODIR)/koi8_u.$(DLEXT) \
	 $(ENCSODIR)/shift_jis.$(DLEXT) \
	 $(ENCSODIR)/utf_16be.$(DLEXT) \
	 $(ENCSODIR)/utf_16le.$(DLEXT) \
	 $(ENCSODIR)/utf_32be.$(DLEXT) \
	 $(ENCSODIR)/utf_32le.$(DLEXT) \
	 $(ENCSODIR)/windows_31j.$(DLEXT) \
	 $(ENCSODIR)/windows_1251.$(DLEXT)

ENCCLEANLIBS = 
ENCCLEANOBJS = $(ENCOBJS:.obj=.exp) $(ENCOBJS:.obj=.lib) $(ENCOBJS:.obj=.pdb) $(ENCOBJS:.obj=.def)
LIBENC=enc/libenc.$(LIBEXT)

TRANSVPATH = $(srcdir)/enc/trans

TRANSCSRCS = $(TRANSVPATH)/big5.c \
	     $(TRANSVPATH)/chinese.c \
	     $(TRANSVPATH)/emoji.c \
	     $(TRANSVPATH)/emoji_iso2022_kddi.c \
	     $(TRANSVPATH)/emoji_sjis_docomo.c \
	     $(TRANSVPATH)/emoji_sjis_kddi.c \
	     $(TRANSVPATH)/emoji_sjis_softbank.c \
	     $(TRANSVPATH)/escape.c \
	     $(TRANSVPATH)/gb18030.c \
	     $(TRANSVPATH)/gbk.c \
	     $(TRANSVPATH)/iso2022.c \
	     $(TRANSVPATH)/japanese.c \
	     $(TRANSVPATH)/japanese_euc.c \
	     $(TRANSVPATH)/japanese_sjis.c \
	     $(TRANSVPATH)/korean.c \
	     $(TRANSVPATH)/single_byte.c \
	     $(TRANSVPATH)/utf8_mac.c \
	     $(TRANSVPATH)/utf_16_32.c

TRANSOBJS = enc/trans/transdb.$(OBJEXT) \
	    enc/trans/big5.$(OBJEXT) \
	    enc/trans/chinese.$(OBJEXT) \
	    enc/trans/emoji.$(OBJEXT) \
	    enc/trans/emoji_iso2022_kddi.$(OBJEXT) \
	    enc/trans/emoji_sjis_docomo.$(OBJEXT) \
	    enc/trans/emoji_sjis_kddi.$(OBJEXT) \
	    enc/trans/emoji_sjis_softbank.$(OBJEXT) \
	    enc/trans/escape.$(OBJEXT) \
	    enc/trans/gb18030.$(OBJEXT) \
	    enc/trans/gbk.$(OBJEXT) \
	    enc/trans/iso2022.$(OBJEXT) \
	    enc/trans/japanese.$(OBJEXT) \
	    enc/trans/japanese_euc.$(OBJEXT) \
	    enc/trans/japanese_sjis.$(OBJEXT) \
	    enc/trans/korean.$(OBJEXT) \
	    enc/trans/single_byte.$(OBJEXT) \
	    enc/trans/utf8_mac.$(OBJEXT) \
	    enc/trans/utf_16_32.$(OBJEXT)

TRANSSOS = $(ENCSODIR)/trans/transdb.$(DLEXT) \
	   $(ENCSODIR)/trans/big5.$(DLEXT) \
	   $(ENCSODIR)/trans/chinese.$(DLEXT) \
	   $(ENCSODIR)/trans/emoji.$(DLEXT) \
	   $(ENCSODIR)/trans/emoji_iso2022_kddi.$(DLEXT) \
	   $(ENCSODIR)/trans/emoji_sjis_docomo.$(DLEXT) \
	   $(ENCSODIR)/trans/emoji_sjis_kddi.$(DLEXT) \
	   $(ENCSODIR)/trans/emoji_sjis_softbank.$(DLEXT) \
	   $(ENCSODIR)/trans/escape.$(DLEXT) \
	   $(ENCSODIR)/trans/gb18030.$(DLEXT) \
	   $(ENCSODIR)/trans/gbk.$(DLEXT) \
	   $(ENCSODIR)/trans/iso2022.$(DLEXT) \
	   $(ENCSODIR)/trans/japanese.$(DLEXT) \
	   $(ENCSODIR)/trans/japanese_euc.$(DLEXT) \
	   $(ENCSODIR)/trans/japanese_sjis.$(DLEXT) \
	   $(ENCSODIR)/trans/korean.$(DLEXT) \
	   $(ENCSODIR)/trans/single_byte.$(DLEXT) \
	   $(ENCSODIR)/trans/utf8_mac.$(DLEXT) \
	   $(ENCSODIR)/trans/utf_16_32.$(DLEXT)

TRANSCLEANLIBS = 
TRANSCLEANOBJS = $(TRANSOBJS:.obj=.exp) $(TRANSOBJS:.obj=.lib) $(TRANSOBJS:.obj=.pdb) $(TRANSOBJS:.obj=.def)
LIBTRANS=enc/libtrans.$(LIBEXT)

encs: {.;$(VPATH)}all
all: {.;$(VPATH)}libenc {.;$(VPATH)}libtrans
libencs: {.;$(VPATH)}libenc {.;$(VPATH)}libtrans
enc: $(ENCSOS)
libenc: $(LIBENC)
trans: $(TRANSSOS)
libtrans: $(LIBTRANS)

$(LIBENC): $(ENCOBJS)
	@$(RM) $@
	$(ECHO) linking statically-linked encoding library $@
	$(Q) $(AR) -machine:x86 -out: $@ $(ENCOBJS)
	@-$(RANLIB) $@ 2> /dev/null || true
$(LIBTRANS): $(TRANSOBJS)
	@$(RM) $@
	$(ECHO) linking statically-linked transcoder library $@
	$(Q) $(AR) -machine:x86 -out: $@ $(TRANSOBJS)
	@-$(RANLIB) $@ 2> /dev/null || true

srcs: $(TRANSCSRCS)

{$(TRANSVPATH)}.trans{$(TRANSVPATH)}.c:
	$(ECHO) generating table from $@
	$(Q)$(MINIRUBY) "$(srcdir)/tool/transcode-tblgen.rb" -vo "$@" "$<"


$(ENCOBJS): {.;$(VPATH)}regenc.h {.;$(VPATH)}oniguruma.h {.;$(VPATH)}config.h {.;$(VPATH)}defines.h
enc/emacs_mule.$(OBJEXT): {.;$(VPATH)}regint.h
enc/euc_jp.$(OBJEXT): {.;$(VPATH)}regint.h
enc/shift_jis.$(OBJEXT): {.;$(VPATH)}regint.h
enc/windows_31j.$(OBJEXT): {.;$(VPATH)}enc/shift_jis.c {.;$(VPATH)}regint.h
$(TRANSOBJS): {.;$(VPATH)}ruby.h {.;$(VPATH)}intern.h {.;$(VPATH)}config.h {.;$(VPATH)}defines.h {.;$(VPATH)}missing.h {.;$(VPATH)}encoding.h {.;$(VPATH)}oniguruma.h {.;$(VPATH)}st.h {.;$(VPATH)}transcode_data.h

$(TRANSVPATH)/big5.c: $(TRANSVPATH)/big5.trans
$(TRANSVPATH)/big5.c: $(TRANSVPATH)/big5-hkscs-tbl.rb $(TRANSVPATH)/big5-uao-tbl.rb $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/chinese.c: $(TRANSVPATH)/chinese.trans
$(TRANSVPATH)/chinese.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/emoji.c: $(TRANSVPATH)/emoji.trans
$(TRANSVPATH)/emoji.c: $(TRANSVPATH)/emoji-exchange-tbl.rb $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/emoji_iso2022_kddi.c: $(TRANSVPATH)/emoji_iso2022_kddi.trans
$(TRANSVPATH)/emoji_iso2022_kddi.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/emoji_sjis_docomo.c: $(TRANSVPATH)/emoji_sjis_docomo.trans
$(TRANSVPATH)/emoji_sjis_docomo.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/emoji_sjis_kddi.c: $(TRANSVPATH)/emoji_sjis_kddi.trans
$(TRANSVPATH)/emoji_sjis_kddi.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/emoji_sjis_softbank.c: $(TRANSVPATH)/emoji_sjis_softbank.trans
$(TRANSVPATH)/emoji_sjis_softbank.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/escape.c: $(TRANSVPATH)/escape.trans
$(TRANSVPATH)/escape.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/gb18030.c: $(TRANSVPATH)/gb18030.trans
$(TRANSVPATH)/gb18030.c: $(TRANSVPATH)/gb18030-tbl.rb $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/gbk.c: $(TRANSVPATH)/gbk.trans
$(TRANSVPATH)/gbk.c: $(TRANSVPATH)/gbk-tbl.rb $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/iso2022.c: $(TRANSVPATH)/iso2022.trans
$(TRANSVPATH)/iso2022.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/japanese.c: $(TRANSVPATH)/japanese.trans
$(TRANSVPATH)/japanese.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/japanese_euc.c: $(TRANSVPATH)/japanese_euc.trans
$(TRANSVPATH)/japanese_euc.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/japanese_sjis.c: $(TRANSVPATH)/japanese_sjis.trans
$(TRANSVPATH)/japanese_sjis.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/korean.c: $(TRANSVPATH)/korean.trans
$(TRANSVPATH)/korean.c: $(TRANSVPATH)/euckr-tbl.rb $(TRANSVPATH)/cp949-tbl.rb $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/single_byte.c: $(TRANSVPATH)/single_byte.trans
$(TRANSVPATH)/single_byte.c:  $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/utf8_mac.c: $(TRANSVPATH)/utf8_mac.trans
$(TRANSVPATH)/utf8_mac.c: $(TRANSVPATH)/utf8_mac-tbl.rb $(srcdir)/tool/transcode-tblgen.rb

$(TRANSVPATH)/utf_16_32.c: $(TRANSVPATH)/utf_16_32.trans
$(TRANSVPATH)/utf_16_32.c:  $(srcdir)/tool/transcode-tblgen.rb

$(ENCSODIR)/encdb.$(DLEXT): enc/encdb.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/encdb.def EXPORTS
	$(Q)echo>> enc/encdb.def Init_encdb
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/encdb.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/encdb.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/big5.$(DLEXT): enc/big5.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/big5.def EXPORTS
	$(Q)echo>> enc/big5.def Init_big5
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/big5.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/big5.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/cp949.$(DLEXT): enc/cp949.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/cp949.def EXPORTS
	$(Q)echo>> enc/cp949.def Init_cp949
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/cp949.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/cp949.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/emacs_mule.$(DLEXT): enc/emacs_mule.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/emacs_mule.def EXPORTS
	$(Q)echo>> enc/emacs_mule.def Init_emacs_mule
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/emacs_mule.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/emacs_mule.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/encinit.$(DLEXT): enc/encinit.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/encinit.def EXPORTS
	$(Q)echo>> enc/encinit.def Init_encinit
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/encinit.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/encinit.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/euc_jp.$(DLEXT): enc/euc_jp.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/euc_jp.def EXPORTS
	$(Q)echo>> enc/euc_jp.def Init_euc_jp
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/euc_jp.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/euc_jp.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/euc_kr.$(DLEXT): enc/euc_kr.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/euc_kr.def EXPORTS
	$(Q)echo>> enc/euc_kr.def Init_euc_kr
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/euc_kr.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/euc_kr.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/euc_tw.$(DLEXT): enc/euc_tw.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/euc_tw.def EXPORTS
	$(Q)echo>> enc/euc_tw.def Init_euc_tw
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/euc_tw.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/euc_tw.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/gb2312.$(DLEXT): enc/gb2312.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/gb2312.def EXPORTS
	$(Q)echo>> enc/gb2312.def Init_gb2312
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/gb2312.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/gb2312.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/gb18030.$(DLEXT): enc/gb18030.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/gb18030.def EXPORTS
	$(Q)echo>> enc/gb18030.def Init_gb18030
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/gb18030.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/gb18030.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/gbk.$(DLEXT): enc/gbk.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/gbk.def EXPORTS
	$(Q)echo>> enc/gbk.def Init_gbk
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/gbk.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/gbk.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_1.$(DLEXT): enc/iso_8859_1.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_1.def EXPORTS
	$(Q)echo>> enc/iso_8859_1.def Init_iso_8859_1
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_1.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_1.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_2.$(DLEXT): enc/iso_8859_2.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_2.def EXPORTS
	$(Q)echo>> enc/iso_8859_2.def Init_iso_8859_2
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_2.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_2.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_3.$(DLEXT): enc/iso_8859_3.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_3.def EXPORTS
	$(Q)echo>> enc/iso_8859_3.def Init_iso_8859_3
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_3.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_3.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_4.$(DLEXT): enc/iso_8859_4.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_4.def EXPORTS
	$(Q)echo>> enc/iso_8859_4.def Init_iso_8859_4
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_4.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_4.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_5.$(DLEXT): enc/iso_8859_5.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_5.def EXPORTS
	$(Q)echo>> enc/iso_8859_5.def Init_iso_8859_5
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_5.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_5.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_6.$(DLEXT): enc/iso_8859_6.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_6.def EXPORTS
	$(Q)echo>> enc/iso_8859_6.def Init_iso_8859_6
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_6.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_6.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_7.$(DLEXT): enc/iso_8859_7.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_7.def EXPORTS
	$(Q)echo>> enc/iso_8859_7.def Init_iso_8859_7
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_7.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_7.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_8.$(DLEXT): enc/iso_8859_8.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_8.def EXPORTS
	$(Q)echo>> enc/iso_8859_8.def Init_iso_8859_8
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_8.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_8.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_9.$(DLEXT): enc/iso_8859_9.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_9.def EXPORTS
	$(Q)echo>> enc/iso_8859_9.def Init_iso_8859_9
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_9.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_9.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_10.$(DLEXT): enc/iso_8859_10.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_10.def EXPORTS
	$(Q)echo>> enc/iso_8859_10.def Init_iso_8859_10
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_10.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_10.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_11.$(DLEXT): enc/iso_8859_11.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_11.def EXPORTS
	$(Q)echo>> enc/iso_8859_11.def Init_iso_8859_11
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_11.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_11.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_13.$(DLEXT): enc/iso_8859_13.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_13.def EXPORTS
	$(Q)echo>> enc/iso_8859_13.def Init_iso_8859_13
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_13.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_13.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_14.$(DLEXT): enc/iso_8859_14.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_14.def EXPORTS
	$(Q)echo>> enc/iso_8859_14.def Init_iso_8859_14
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_14.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_14.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_15.$(DLEXT): enc/iso_8859_15.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_15.def EXPORTS
	$(Q)echo>> enc/iso_8859_15.def Init_iso_8859_15
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_15.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_15.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/iso_8859_16.$(DLEXT): enc/iso_8859_16.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/iso_8859_16.def EXPORTS
	$(Q)echo>> enc/iso_8859_16.def Init_iso_8859_16
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/iso_8859_16.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/iso_8859_16.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/koi8_r.$(DLEXT): enc/koi8_r.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/koi8_r.def EXPORTS
	$(Q)echo>> enc/koi8_r.def Init_koi8_r
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/koi8_r.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/koi8_r.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/koi8_u.$(DLEXT): enc/koi8_u.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/koi8_u.def EXPORTS
	$(Q)echo>> enc/koi8_u.def Init_koi8_u
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/koi8_u.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/koi8_u.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/shift_jis.$(DLEXT): enc/shift_jis.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/shift_jis.def EXPORTS
	$(Q)echo>> enc/shift_jis.def Init_shift_jis
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/shift_jis.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/shift_jis.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/utf_16be.$(DLEXT): enc/utf_16be.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/utf_16be.def EXPORTS
	$(Q)echo>> enc/utf_16be.def Init_utf_16be
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/utf_16be.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/utf_16be.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/utf_16le.$(DLEXT): enc/utf_16le.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/utf_16le.def EXPORTS
	$(Q)echo>> enc/utf_16le.def Init_utf_16le
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/utf_16le.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/utf_16le.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/utf_32be.$(DLEXT): enc/utf_32be.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/utf_32be.def EXPORTS
	$(Q)echo>> enc/utf_32be.def Init_utf_32be
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/utf_32be.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/utf_32be.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/utf_32le.$(DLEXT): enc/utf_32le.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/utf_32le.def EXPORTS
	$(Q)echo>> enc/utf_32le.def Init_utf_32le
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/utf_32le.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/utf_32le.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/windows_31j.$(DLEXT): enc/windows_31j.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/windows_31j.def EXPORTS
	$(Q)echo>> enc/windows_31j.def Init_windows_31j
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/windows_31j.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/windows_31j.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(ENCSODIR)/windows_1251.$(DLEXT): enc/windows_1251.$(OBJEXT)
	$(ECHO) linking encoding $(@F)
	$(Q)echo> enc/windows_1251.def EXPORTS
	$(Q)echo>> enc/windows_1251.def Init_windows_1251
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/windows_1251.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/$(*F:.so=).lib -pdb:enc/$(*F:.so=).pdb -def:enc/windows_1251.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/transdb.$(DLEXT): enc/trans/transdb.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/transdb.def EXPORTS
	$(Q)echo>> enc/trans/transdb.def Init_transdb
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/transdb.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/transdb.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/big5.$(DLEXT): enc/trans/big5.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/big5.def EXPORTS
	$(Q)echo>> enc/trans/big5.def Init_big5
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/big5.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/big5.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/chinese.$(DLEXT): enc/trans/chinese.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/chinese.def EXPORTS
	$(Q)echo>> enc/trans/chinese.def Init_chinese
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/chinese.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/chinese.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/emoji.$(DLEXT): enc/trans/emoji.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/emoji.def EXPORTS
	$(Q)echo>> enc/trans/emoji.def Init_emoji
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/emoji.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/emoji.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/emoji_iso2022_kddi.$(DLEXT): enc/trans/emoji_iso2022_kddi.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/emoji_iso2022_kddi.def EXPORTS
	$(Q)echo>> enc/trans/emoji_iso2022_kddi.def Init_emoji_iso2022_kddi
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/emoji_iso2022_kddi.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/emoji_iso2022_kddi.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/emoji_sjis_docomo.$(DLEXT): enc/trans/emoji_sjis_docomo.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/emoji_sjis_docomo.def EXPORTS
	$(Q)echo>> enc/trans/emoji_sjis_docomo.def Init_emoji_sjis_docomo
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/emoji_sjis_docomo.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/emoji_sjis_docomo.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/emoji_sjis_kddi.$(DLEXT): enc/trans/emoji_sjis_kddi.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/emoji_sjis_kddi.def EXPORTS
	$(Q)echo>> enc/trans/emoji_sjis_kddi.def Init_emoji_sjis_kddi
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/emoji_sjis_kddi.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/emoji_sjis_kddi.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/emoji_sjis_softbank.$(DLEXT): enc/trans/emoji_sjis_softbank.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/emoji_sjis_softbank.def EXPORTS
	$(Q)echo>> enc/trans/emoji_sjis_softbank.def Init_emoji_sjis_softbank
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/emoji_sjis_softbank.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/emoji_sjis_softbank.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/escape.$(DLEXT): enc/trans/escape.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/escape.def EXPORTS
	$(Q)echo>> enc/trans/escape.def Init_escape
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/escape.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/escape.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/gb18030.$(DLEXT): enc/trans/gb18030.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/gb18030.def EXPORTS
	$(Q)echo>> enc/trans/gb18030.def Init_gb18030
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/gb18030.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/gb18030.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/gbk.$(DLEXT): enc/trans/gbk.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/gbk.def EXPORTS
	$(Q)echo>> enc/trans/gbk.def Init_gbk
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/gbk.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/gbk.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/iso2022.$(DLEXT): enc/trans/iso2022.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/iso2022.def EXPORTS
	$(Q)echo>> enc/trans/iso2022.def Init_iso2022
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/iso2022.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/iso2022.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/japanese.$(DLEXT): enc/trans/japanese.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/japanese.def EXPORTS
	$(Q)echo>> enc/trans/japanese.def Init_japanese
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/japanese.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/japanese.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/japanese_euc.$(DLEXT): enc/trans/japanese_euc.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/japanese_euc.def EXPORTS
	$(Q)echo>> enc/trans/japanese_euc.def Init_japanese_euc
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/japanese_euc.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/japanese_euc.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/japanese_sjis.$(DLEXT): enc/trans/japanese_sjis.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/japanese_sjis.def EXPORTS
	$(Q)echo>> enc/trans/japanese_sjis.def Init_japanese_sjis
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/japanese_sjis.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/japanese_sjis.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/korean.$(DLEXT): enc/trans/korean.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/korean.def EXPORTS
	$(Q)echo>> enc/trans/korean.def Init_korean
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/korean.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/korean.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/single_byte.$(DLEXT): enc/trans/single_byte.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/single_byte.def EXPORTS
	$(Q)echo>> enc/trans/single_byte.def Init_single_byte
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/single_byte.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/single_byte.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/utf8_mac.$(DLEXT): enc/trans/utf8_mac.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/utf8_mac.def EXPORTS
	$(Q)echo>> enc/trans/utf8_mac.def Init_utf8_mac
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/utf8_mac.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/utf8_mac.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

$(TRANSSODIR)/utf_16_32.$(DLEXT): enc/trans/utf_16_32.$(OBJEXT)
	$(ECHO) linking transcoder $(@F)
	$(Q)echo> enc/trans/utf_16_32.def EXPORTS
	$(Q)echo>> enc/trans/utf_16_32.def Init_utf_16_32
	$(Q)$(MAKEDIRS) "$(@D)"
	$(Q)$(LDSHARED) -Fe$(@) enc/trans/utf_16_32.$(OBJEXT) $(LIBS) $(LOCAL_LIBS) -link $(DLDFLAGS) -implib:enc/trans/$(*F:.so=).lib -pdb:enc/trans/$(*F:.so=).pdb -def:enc/trans/utf_16_32.def
	$(Q) @if exist $(@).manifest $(RUBY) -run -e wait_writable -- -n 10 $(@)
	$(Q) @if exist $(@).manifest mt -nologo -manifest $(@).manifest -outputresource:$(@);2
	$(Q) @if exist $(@).manifest $(RM) $(@:/=\).manifest

enc/encdb.$(OBJEXT): $(encsrcdir)/encdb.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/encdb.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/encdb.c

enc/big5.$(OBJEXT): $(encsrcdir)/big5.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/big5.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/big5.c

enc/cp949.$(OBJEXT): $(encsrcdir)/cp949.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/cp949.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/cp949.c

enc/emacs_mule.$(OBJEXT): $(encsrcdir)/emacs_mule.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/emacs_mule.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/emacs_mule.c

enc/encinit.$(OBJEXT): $(encsrcdir)/encinit.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/encinit.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/encinit.c

enc/euc_jp.$(OBJEXT): $(encsrcdir)/euc_jp.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/euc_jp.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/euc_jp.c

enc/euc_kr.$(OBJEXT): $(encsrcdir)/euc_kr.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/euc_kr.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/euc_kr.c

enc/euc_tw.$(OBJEXT): $(encsrcdir)/euc_tw.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/euc_tw.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/euc_tw.c

enc/gb2312.$(OBJEXT): $(encsrcdir)/gb2312.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/gb2312.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/gb2312.c

enc/gb18030.$(OBJEXT): $(encsrcdir)/gb18030.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/gb18030.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/gb18030.c

enc/gbk.$(OBJEXT): $(encsrcdir)/gbk.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/gbk.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/gbk.c

enc/iso_8859_1.$(OBJEXT): $(encsrcdir)/iso_8859_1.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_1.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_1.c

enc/iso_8859_2.$(OBJEXT): $(encsrcdir)/iso_8859_2.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_2.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_2.c

enc/iso_8859_3.$(OBJEXT): $(encsrcdir)/iso_8859_3.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_3.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_3.c

enc/iso_8859_4.$(OBJEXT): $(encsrcdir)/iso_8859_4.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_4.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_4.c

enc/iso_8859_5.$(OBJEXT): $(encsrcdir)/iso_8859_5.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_5.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_5.c

enc/iso_8859_6.$(OBJEXT): $(encsrcdir)/iso_8859_6.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_6.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_6.c

enc/iso_8859_7.$(OBJEXT): $(encsrcdir)/iso_8859_7.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_7.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_7.c

enc/iso_8859_8.$(OBJEXT): $(encsrcdir)/iso_8859_8.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_8.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_8.c

enc/iso_8859_9.$(OBJEXT): $(encsrcdir)/iso_8859_9.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_9.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_9.c

enc/iso_8859_10.$(OBJEXT): $(encsrcdir)/iso_8859_10.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_10.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_10.c

enc/iso_8859_11.$(OBJEXT): $(encsrcdir)/iso_8859_11.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_11.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_11.c

enc/iso_8859_13.$(OBJEXT): $(encsrcdir)/iso_8859_13.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_13.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_13.c

enc/iso_8859_14.$(OBJEXT): $(encsrcdir)/iso_8859_14.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_14.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_14.c

enc/iso_8859_15.$(OBJEXT): $(encsrcdir)/iso_8859_15.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_15.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_15.c

enc/iso_8859_16.$(OBJEXT): $(encsrcdir)/iso_8859_16.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/iso_8859_16.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/iso_8859_16.c

enc/koi8_r.$(OBJEXT): $(encsrcdir)/koi8_r.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/koi8_r.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/koi8_r.c

enc/koi8_u.$(OBJEXT): $(encsrcdir)/koi8_u.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/koi8_u.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/koi8_u.c

enc/shift_jis.$(OBJEXT): $(encsrcdir)/shift_jis.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/shift_jis.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/shift_jis.c

enc/utf_16be.$(OBJEXT): $(encsrcdir)/utf_16be.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/utf_16be.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/utf_16be.c

enc/utf_16le.$(OBJEXT): $(encsrcdir)/utf_16le.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/utf_16le.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/utf_16le.c

enc/utf_32be.$(OBJEXT): $(encsrcdir)/utf_32be.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/utf_32be.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/utf_32be.c

enc/utf_32le.$(OBJEXT): $(encsrcdir)/utf_32le.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/utf_32le.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/utf_32le.c

enc/windows_31j.$(OBJEXT): $(encsrcdir)/windows_31j.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/windows_31j.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/windows_31j.c

enc/windows_1251.$(OBJEXT): $(encsrcdir)/windows_1251.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/windows_1251.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/windows_1251.c

enc/trans/transdb.$(OBJEXT): $(encsrcdir)/trans/transdb.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/transdb.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/transdb.c

enc/trans/big5.$(OBJEXT): $(encsrcdir)/trans/big5.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/big5.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/big5.c

enc/trans/chinese.$(OBJEXT): $(encsrcdir)/trans/chinese.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/chinese.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/chinese.c

enc/trans/emoji.$(OBJEXT): $(encsrcdir)/trans/emoji.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/emoji.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/emoji.c

enc/trans/emoji_iso2022_kddi.$(OBJEXT): $(encsrcdir)/trans/emoji_iso2022_kddi.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/emoji_iso2022_kddi.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/emoji_iso2022_kddi.c

enc/trans/emoji_sjis_docomo.$(OBJEXT): $(encsrcdir)/trans/emoji_sjis_docomo.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/emoji_sjis_docomo.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/emoji_sjis_docomo.c

enc/trans/emoji_sjis_kddi.$(OBJEXT): $(encsrcdir)/trans/emoji_sjis_kddi.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/emoji_sjis_kddi.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/emoji_sjis_kddi.c

enc/trans/emoji_sjis_softbank.$(OBJEXT): $(encsrcdir)/trans/emoji_sjis_softbank.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/emoji_sjis_softbank.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/emoji_sjis_softbank.c

enc/trans/escape.$(OBJEXT): $(encsrcdir)/trans/escape.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/escape.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/escape.c

enc/trans/gb18030.$(OBJEXT): $(encsrcdir)/trans/gb18030.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/gb18030.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/gb18030.c

enc/trans/gbk.$(OBJEXT): $(encsrcdir)/trans/gbk.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/gbk.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/gbk.c

enc/trans/iso2022.$(OBJEXT): $(encsrcdir)/trans/iso2022.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/iso2022.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/iso2022.c

enc/trans/japanese.$(OBJEXT): $(encsrcdir)/trans/japanese.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/japanese.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/japanese.c

enc/trans/japanese_euc.$(OBJEXT): $(encsrcdir)/trans/japanese_euc.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/japanese_euc.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/japanese_euc.c

enc/trans/japanese_sjis.$(OBJEXT): $(encsrcdir)/trans/japanese_sjis.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/japanese_sjis.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/japanese_sjis.c

enc/trans/korean.$(OBJEXT): $(encsrcdir)/trans/korean.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/korean.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/korean.c

enc/trans/single_byte.$(OBJEXT): $(encsrcdir)/trans/single_byte.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/single_byte.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/single_byte.c

enc/trans/utf8_mac.$(OBJEXT): $(encsrcdir)/trans/utf8_mac.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/utf8_mac.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/utf8_mac.c

enc/trans/utf_16_32.$(OBJEXT): $(encsrcdir)/trans/utf_16_32.c
	-$(Q)$(MAKEDIRS) "$(@D)"
	$(ECHO) compiling $(encsrcdir)/trans/utf_16_32.c
	$(Q)$(CC) $(INCFLAGS) $(CFLAGS) $(CPPFLAGS) $(COUTFLAG)$(@) -c -Tc$(encsrcdir)/trans/utf_16_32.c


enc/encdb.$(OBJEXT): {.;$(VPATH)}encdb.h
enc/trans/transdb.$(OBJEXT): {.;$(VPATH)}transdb.h

clean:
	$(Q)$(RM) $(ENCSOS:/=\)
	$(Q)$(RM) $(LIBENC:/=\)
	$(Q)$(RM) $(ENCOBJS:/=\)
	$(Q)$(RM) $(ENCCLEANOBJS:/=\)
	$(Q)$(RM) $(ENCCLEANLIBS:/=\)
	$(Q)$(RM) $(TRANSSOS:/=\)
	$(Q)$(RM) $(LIBTRANS:/=\)
	$(Q)$(RM) $(TRANSOBJS:/=\)
	$(Q)$(RM) $(TRANSCLEANOBJS:/=\)
	$(Q)$(RM) $(TRANSCLEANLIBS:/=\)
	-$(Q)$(RMDIR) enc\trans
	-$(Q)$(RMDIR) enc
	-$(Q)$(RMDIR) $(TRANSSODIR:/=\)
	-$(Q)$(RMDIR) $(ENCSODIR:/=\)

clean-srcs:
	$(Q)$(RM) $(TRANSCSRCS:/=\)
	-$(Q)$(RMDIR) enc\trans
	$(Q)$(RM) enc/unicode/name2ctype.h
	-$(Q)$(RMDIR) enc\unicode
	-$(Q)$(RMDIR) enc


